
-- Heavily Inspired by DKPmon / Bidder

local tablet = AceLibrary("Tablet-2.0")

local _G = getfenv(0)

local function CreateButton(parent, width, height, text, xoffs, yoffs)
    local b = CreateFrame("Button", nil, parent, "UIPanelButtonTemplate")
    b:SetWidth(width); b:SetHeight(height)
    b:SetText(text)
    b:SetAlpha(1)
    if xoffs ~= nil and yoffs ~= nil then
        b:SetPoint("TOPLEFT", parent, "TOPLEFT", xoffs, yoffs)
    end
    return b
end

function RootsBidder:CreateBidLine(parent, line)
	local tab = {}
	local f,t,m, i
	local spacing=25
	
    t = parent:CreateFontString()
	t:SetPoint("TOPLEFT", parent, "TOPLEFT", 10, -10-line*spacing)
	t:SetFontObject(GameFontNormal); t:SetWidth(150)
	t:SetText("")
--~     t:SetJustifyH("LEFT")
	tab.item = t;
    
    m = parent:CreateFontString()
	m:SetPoint("TOPLEFT", parent, "TOPLEFT", 155, -10-line*spacing)
	m:SetFontObject(GameFontNormal); m:SetWidth(30)
	m:SetText("")
	tab.min = m;	
    
	-- Create the line for Max bid
	m = parent:CreateFontString()
	m:SetPoint("TOPLEFT", parent, "TOPLEFT", 325, -10-line*spacing)
	m:SetFontObject(GameFontNormal); m:SetWidth(30)
	m:SetText("")
	tab.max = m;	
    
    i = CreateFrame("Button", nil, parent)
	i:SetWidth(20)
	i:SetHeight(20)
	i:ClearAllPoints()
	i:SetPoint("TOPLEFT", parent, "TOPLEFT", 5, -7-line*spacing)
--~ 	i:SetNormalTexture("Interface\\Icons\\INV_Enchant_ShardNexusLarge")
--~ 	i:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	tab.icon = i
    
    
    

	-- Create the FontString for the Bid
	t = parent:CreateFontString()
	t:SetPoint("TOPLEFT", parent, "TOPLEFT", 295, -10-line*spacing)
	t:SetFontObject(GameFontNormal); t:SetWidth(30)
	t:SetText("")
    --~ 	t:SetJustifyV("MIDDLE")
	tab.bid = t;

	-- Create the fontstring & clickable frame for the winner name
	f = CreateFrame("Frame", nil, parent)
	f:SetWidth(165); f:SetHeight(spacing-5);
	f:EnableMouse(true)
	f:SetPoint("TOPLEFT", parent, "TOPLEFT", 190, -10-line*spacing)
    f:SetBackdropColor(1, 1, 1, 0.5)
    
    tablet:Register(f,
    'children', function()
        local cat = tablet:AddCategory()
        cat:AddLine(
            'text', "No Bids Yet"
        )
        tablet:SetTitle("Current Bids")
    end
    )
	tab.frame = f
	t = f:CreateFontString()
	t:SetPoint("TOPLEFT", parent, "TOPLEFT", 190, -10-line*spacing);  
	t:SetFontObject(GameFontNormal); t:SetWidth(100)
	t:SetText("")
	tab.player = t
    
	t = CreateFrame("Button", nil, parent)
	t:SetWidth(20); t:SetHeight(20)
    t:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up")
	t:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
	t:SetText("Place Bid")
	t:SetPoint("TOPLEFT", parent, "TOPLEFT", 375, -7-line*spacing)
	t:SetScript("OnClick", function() RootsBidder:PlaceBid(line,5) end)
	tab.BidButton = t
    
    t = CreateFrame("Button", nil, parent)
	t:SetWidth(20); t:SetHeight(20)
    t:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")
	t:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	t:SetText("Place Bid")
	t:SetPoint("TOPLEFT", parent, "TOPLEFT", 395, -7-line*spacing)
	t:SetScript("OnClick", function() RootsBidder:PassBid(line) end)
	tab.PassButton = t
    
    t = CreateFrame("Button", nil, parent)
	t:SetWidth(20); t:SetHeight(20)
    t:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
	t:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
	t:SetText("Place Bid")
	t:SetPoint("TOPLEFT", parent, "TOPLEFT", 355, -7-line*spacing)
	t:SetScript("OnClick", function() RootsBidder:PlaceBid(line,25) end)
	tab.NeedButton = t
    
    self:RegisterCandyBar("BidTimer"..line, 20, "Time:", "", "green", "yellow", "red")
    self:SetCandyBarTexture("BidTimer"..line, "Interface\\Addons\\RootsBidder\\Textures\\Charcoal")
    self:SetCandyBarPoint("BidTimer"..line, "BOTTOMLEFT", tab.frame, "BOTTOMLEFT", 210, 5)
--~     self:SetCandyBarTextColor("BidTimer"..line, "green", 0)
--~     self:SetCandyBarColor("BidTimer"..line, "green", 0.1)
--~     self:SetCandyBarText("BidTimer"..line,"")
    self:SetCandyBarWidth("BidTimer"..line,100)
	tab.max:Hide()
	tab.frame:Hide()
	tab.bid:Hide()
    tab.BidButton:Hide()
    tab.NeedButton:Hide()
    tab.PassButton:Hide()
    tab.icon:Hide()
	return tab
end

function RootsBidder:CreateBidFrame()
	local f, b, c , bb , icon
	self.GUI = {}
	local frame = CreateFrame("Frame", "RootsBidder Frame", UIParent)
	frame:SetWidth(520)
	frame:SetHeight(300)
    
	frame:SetBackdrop( {
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize=16, edgeSize=16,
		insets = {left=4, right=4, top=4, bottom=4}
        } )
	--frame:SetBackdropColor(0.16, 0.28, 0.61, 0.9) -- Blueish
	--frame:SetBackdropColor(0.29, 0.72, 0.70, 0.9) --Cyan
	--frame:SetBackdropColor(0.89, 0.15, 0.22, 0.9) -- Red
    frame:SetBackdropColor(0.1, 0.1, 0.1, 0.5)
    
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetPoint("CENTER", Coord_Xframe, Coord_Yframe)
	frame:CreateTitleRegion()
	local tR= frame:GetTitleRegion()
	tR:SetWidth(130); tR:SetHeight(20)
	tR:SetPoint("CENTER", frame, "TOP", 0, -10)

	t = frame:CreateFontString()
	t:SetAllPoints(tR)
	t:SetTextColor(1.0, 0.819, 0.0);
	t:SetWidth(500)
	t:SetFontObject(GameFontNormalSmall)
	t:SetText("Bidding is Closed atm.")
	self.GUI.title = t
    
	b = CreateFrame("Button", nil, frame, "UIPanelCloseButton")
	b:SetPoint("CENTER", frame, "TOPRIGHT", -16, -16)
	b:Show()    
		
	t = frame:CreateFontString()
	t:SetPoint("TOPLEFT", frame, "TOPLEFT", 10,-20)
	t:SetFontObject(GameFontWhite); t:SetWidth(150)
	t:SetText("Item")
    
    t = frame:CreateFontString()
	t:SetPoint("TOPLEFT", frame, "TOPLEFT", 155,-20)
	t:SetFontObject(GameFontWhite); t:SetWidth(30)
	t:SetText("Min")

	t = frame:CreateFontString()
	t:SetPoint("TOPLEFT", frame, "TOPLEFT", 190,-20)
	t:SetFontObject(GameFontWhite); t:SetWidth(100)
	t:SetText("Player")

	t = frame:CreateFontString()
	t:SetPoint("TOPLEFT", frame, "TOPLEFT", 295,-20)
	t:SetFontObject(GameFontWhite); t:SetWidth(30)
	t:SetText("Bid")
    
    t = frame:CreateFontString()
	t:SetPoint("TOPLEFT", frame, "TOPLEFT", 325,-20)
	t:SetFontObject(GameFontWhite); t:SetWidth(30)
	t:SetText("Max")
	
	RootsBidder.GUI.bids = {
		[10]=self:CreateBidLine(frame, 0),
		[1]=self:CreateBidLine(frame, 1),
		[2]=self:CreateBidLine(frame, 2),
		[3]=self:CreateBidLine(frame, 3),
		[4]=self:CreateBidLine(frame, 4),
		[5]=self:CreateBidLine(frame, 5),
		[6]=self:CreateBidLine(frame, 6),
		[7]=self:CreateBidLine(frame, 7),
		[8]=self:CreateBidLine(frame, 8),
		[9]=self:CreateBidLine(frame, 9)        
	}
    
	self.GUI.frame = frame
	frame:Hide()
end

function RootsBidder:InitBidLine(line)
	if self.GUI.frame == nil then self:CreateBidFrame(); end
	local tab = self.GUI.bids[line]
    tab.item:SetText(self.LootList[line].link)
    tab.min:SetText(self.LootList[line].min)
    local itemname ,iString, iquality ,_,_,_,_,_,_,iTexture = GetItemInfo(self.LootList[line].id)
    local red,green, blue ,hex = GetItemQualityColor(iquality);
    tab.item:SetTextColor(red, green, blue,hex)
    if self.LootList[line].bids[1] ~= nil then 
        tab.max:SetText(self.LootList[line].bids[self.LootList[line].bidcount].max)
        tab.bid:SetText(self.LootList[line].bids[self.LootList[line].bidcount].bid)
        tab.player:SetText(self.LootList[line].bids[self.LootList[line].bidcount].player)
    end
    tablet:Register(tab.frame,
    'children', function()
        local cat = tablet:AddCategory('columns', 3)
        for counter in pairs(self.LootList[line].bids) do
            cat:AddLine(
                'text', self.LootList[line].bids[counter].player ,'text2', self.LootList[line].bids[counter].bid,'text3',"Max " .. self.LootList[line].bids[counter].max
            )
        end
        tablet:SetTitle("Current Bids")
    end
    )    
    
    
    tab.icon:SetNormalTexture(iTexture)
	tab.icon:SetScript("OnEnter", function()
		local item = "item:" .. self.LootList[line].id .. ":0:0:0"
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink(item);
		CursorUpdate();
	end)
	tab.icon:SetScript("OnLeave", function() GameTooltip:Hide() end)
    tab.item:Show()
    tab.min:Show()
    tab.max:Show()
    tab.frame:Show()
    tab.bid:Show()
    tab.player:Show()
    tab.BidButton:Show()
    tab.icon:Show()
    tab.NeedButton:Show()
    tab.PassButton:Show()
    self:StartCandyBar("BidTimer"..line)
end

function RootsBidder:showGUI()
	if RootsBidder.GUI.frame == nil then RootsBidder:CreateBidFrame() end
	self.GUI.frame:Show()
end

function RootsBidder:UpdateBidLine(line)
    if self.GUI.frame == nil then self:CreateBidFrame();end
    local tab = self.GUI.bids[line]
    tab.player:SetText(RootsBidder.bids[line].player)
    tab.bid:SetText(RootsBidder.bids[line].bid)
    tab.max:SetText(RootsBidder.bids[line].max)
    tab.item:SetText(self.bids[line].link)
    tab.min:SetText(self.bids[line].min)
    if RootsBidder.bids[line].bid==0 then
        tab.player:Hide()
        tab.max:Hide()
        tab.bid:Hide()
        tab.frame:Hide()
    end
end

function RootsBidder:HideBidLine(line)
	if self.GUI.frame == nil then self:CreateBidFrame();end
	local tab = self.GUI.bids[line]
	tab.frame:Hide()
	tab.bid:Hide()
    tab.item:Hide()
	tab.player:Hide()
	tab.max:Hide()
    tab.BidButton:Hide()
    tab.NeedButton:Hide()
    tab.PassButton:Hide()
    tab.min:Hide()
end

function RootsBidder:ResetBidLine(line)
    if self.GUI.frame == nil then self:CreateBidFrame(); end
	local tab = self.GUI.bids[line]
    tab.item:SetText("")
    tab.min:SetText("")
    tab.max:SetText("")
    tab.bid:SetText("")
    tab.player:SetText("")
    tab.frame:Hide()
    tab.item:Hide()
    tab.min:Hide()
    tab.max:Hide()
    tab.bid:Hide()
    tab.player:Hide()
end
